---
title: WindowOrWorkerGlobalScope.queueMicrotask()
slug: Web/API/WindowOrWorkerGlobalScope/queueMicrotask
tags:
  - API
  - HTML DOM
  - Intervals
  - JavaScript
  - Method
  - Microtask
  - Performance
  - Reference
  - Scheduling
  - ServiceWorker
  - SharedWorker
  - Tasks
  - Timers
  - Window
  - WindowOrWorkerGlobalScope
  - Worker
  - asynchronous
  - queueMicrotask
  - setTimeout
---
<div>{{APIRef("HTML DOM")}}</div>

<p><span class="seoSummary">The <code><strong>queueMicrotask()</strong></code> method, which is exposed on the {{domxref("Window")}} or {{domxref("Worker")}} interface, queues a microtask to be executed at a safe time prior to control returning to the browser's event loop.</span> The microtask is a short function which will run after the current task has completed its work and when there is no other code waiting to be run before control of the execution context is returned to the browser's event loop.</p>

<p>This lets your code run without interfering with any other, potentially higher priority, code that is pending, but before the browser regains control over the execution context, potentially depending on work you need to complete. You can learn more about how to use microtasks and why you might choose to do so in our <a href="/en-US/docs/Web/API/HTML_DOM_API/Microtask_guide">microtask guide</a>.</p>

<p>The importance of microtasks comes in its ability to perform tasks asynchronously but in a specific order. See <a href="/en-US/docs/Web/API/HTML_DOM_API/Microtask_guide">Using microtasks in JavaScript with queueMicrotask()</a> for more details.</p>

<p>Microtasks are especially useful for libraries and frameworks that need to perform final cleanup or other just-before-rendering tasks.</p>

<p><code>queueMicrotask()</code> is exposed on the {{domxref("WindowOrWorkerGlobalScope")}} mixin.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>scope</em>.queueMicrotask(<em>function</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>function</code></dt>
 <dd>A {{jsxref("function")}} to be executed when the browser engine determines it is safe to call your code. Enqueued microtasks are executed after all pending tasks have completed but before yielding control to the browser's event loop.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code>.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">self.queueMicrotask(() =&gt; {
  // function contents here
})</pre>

<p>Taken from the <a href="https://html.spec.whatwg.org/multipage/timers-and-user-prompts.html#microtask-queuing">queueMicrotask spec</a>:</p>

<pre class="brush: js">MyElement.prototype.loadData = function (url) {
  if (this._cache[url]) {
    queueMicrotask(() =&gt; {
      this._setData(this._cache[url]);
      this.dispatchEvent(new Event("load"));
    });
  } else {
    fetch(url).then(res =&gt; res.arrayBuffer()).then(data =&gt; {
      this._cache[url] = data;
      this._setData(data);
      this.dispatchEvent(new Event("load"));
    });
  }
};</pre>

<h2 id="When_queueMicrotask_isnt_available">When queueMicrotask() isn't available</h2>

<p>The code below is basically a monkey-patch for <code>queueMicrotask()</code> for modern engines. It creates a microtask by using a promise that resolves immediately.</p>

<pre class="brush: js">if (typeof window.queueMicrotask !== "function") {
  window.queueMicrotask = function (callback) {
    Promise.resolve()
      .then(callback)
      .catch(e =&gt; setTimeout(() =&gt; { throw e; })); // report exceptions
  };
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th>Specification</th>
   <th>Status</th>
   <th>Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("HTML WHATWG", "timers-and-user-prompts.html#microtask-queuing", "self.queueMicrotask()")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.<br>
<br>
NOTE: data on this has been submitted; just waiting on it to be reviewed, merged, and for a new data release before it will show up here. See https://github.com/mdn/browser-compat-data/pull/4754 for PR.</div>

<p>{{Compat("api.WindowOrWorkerGlobalScope.queueMicrotask")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/HTML_DOM_API/Microtask_guide">Using microtasks in JavaScript with queueMicrotask()</a></li>
 <li><a href="/en-US/docs/Learn/JavaScript/Asynchronous">Asynchronous JavaScript</a></li>
 <li><a href="https://github.com/fergald/docs/blob/master/explainers/queueMicrotask.md">queueMicrotask explainer</a></li>
 <li><a href="https://jakearchibald.com/2015/tasks-microtasks-queues-and-schedules/">Tasks, microtasks, queues and schedules</a> by Jake Archibald</li>
</ul>
